(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/coercion'), require('prismjs'), require('rxjs'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@wizdm/prism', ['exports', '@angular/core', '@angular/cdk/coercion', 'prismjs', 'rxjs', 'rxjs/operators', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.wizdm = global.wizdm || {}, global.wizdm.prism = {}), global.ng.core, global.ng.cdk.coercion, global.prismjs, global.rxjs, global.rxjs.operators, global.ng.common));
}(this, (function (exports, core, coercion, prismjs, rxjs, operators, common) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var prismjs__default = /*#__PURE__*/_interopDefaultLegacy(prismjs);

    /** Prism Language Modules Token */
    var LANGUAGE_MODULES = new core.InjectionToken('wizdm.prism.language.modules');
    /** @dynamic - tells ngc to ignore the error on type PrismLanguages generated by strictEmitMetadata: true */
    var PrismService = /** @class */ (function () {
        function PrismService(languages) {
            this.languages = languages;
        }
        /** Tokenizes the input source by loading the grammar dynamically whenever necessary */
        PrismService.prototype.tokenize = function (source, language) {
            // Skips invalid source
            if (!source) {
                return rxjs.of(['']);
            }
            // Loads the grammar and tokenizes the source accordingly
            return this.loadGrammar(language).pipe(operators.map(function (grammar) { return !!grammar ? prismjs__default['default'].tokenize(source, grammar) : [source]; }));
        };
        /** Loads the Grammar */
        PrismService.prototype.loadGrammar = function (language) {
            // No language, no grammar...
            if (!language) {
                return rxjs.of(undefined);
            }
            // Verifies the grammar has been already loaded
            if (prismjs__default['default'].languages[language]) {
                return rxjs.of(prismjs__default['default'].languages[language]);
            }
            // Attempts to load the grammar dynamically
            var loader = this.languages && this.languages.find(function (_a) {
                var name = _a.name;
                // Matches the requested language
                return Array.isArray(name) ? (name.indexOf(language) >= 0) : (name === language || name === '*');
            });
            // Abort when no loader is found
            if (!loader) {
                return rxjs.of(undefined);
            }
            // Resolves the grammar by loading the module
            return rxjs.from(loader.load(language)).pipe(operators.map(function () { return prismjs__default['default'].languages[language]; }));
        };
        return PrismService;
    }());
    PrismService.decorators = [
        { type: core.Injectable }
    ];
    /** @nocollapse */
    PrismService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [LANGUAGE_MODULES,] }] }
    ]; };

    /** Perform code hilighting by processing an input text to be rendered into an angular template
     * Using prism as tokenizer @see {https://github.com/PrismJS/prism} */
    var PrismHighlighter = /** @class */ (function () {
        function PrismHighlighter(prism) {
            this.prism = prism;
            this.disabled = false;
        }
        Object.defineProperty(PrismHighlighter.prototype, "clazz", {
            /** Applies the proper classes to the host <pre> element */
            get: function () {
                return "wm-prism" + (this.disabled ? '' : ' language-none');
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PrismHighlighter.prototype, "disableHighlight", {
            /** Disables the highlighting */
            set: function (value) { this.disabled = coercion.coerceBooleanProperty(value); },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PrismHighlighter.prototype, "source", {
            /** Parses the source text */
            set: function (source) {
                this.tokens$ = this.prism.tokenize(source, this.language);
            },
            enumerable: false,
            configurable: true
        });
        return PrismHighlighter;
    }());
    PrismHighlighter.decorators = [
        { type: core.Component, args: [{
                    selector: 'pre[wm-prism]',
                    template: "\n<code *ngIf=\"!disabled; else transclude\" [tokenize]=\"tokens$ | async\"></code>\n\n<ng-template #transclude>\n  <ng-content></ng-content>\n</ng-template>"
                },] }
    ];
    /** @nocollapse */
    PrismHighlighter.ctorParameters = function () { return [
        { type: PrismService }
    ]; };
    PrismHighlighter.propDecorators = {
        clazz: [{ type: core.HostBinding, args: ['class',] }],
        disableHighlight: [{ type: core.Input, args: ['disabled',] }],
        language: [{ type: core.Input }],
        source: [{ type: core.Input, args: ['wm-prism',] }]
    };

    // Forces prism to run in manual mode
    (function (window) {
        window.Prism = (window.Prism || {});
        window.Prism.manual = true;
    }(window || {}));

    var PrismTokenizer = /** @class */ (function () {
        function PrismTokenizer() {
        }
        Object.defineProperty(PrismTokenizer.prototype, "tokenize", {
            /** Tokenizes the input string or pass along the already tokenized array */
            set: function (source) {
                this.tokens = typeof (source) === 'string' ? [source] : source;
            },
            enumerable: false,
            configurable: true
        });
        /** Helper for rendering strings */
        PrismTokenizer.prototype.isString = function (token) { return typeof (token) === 'string'; };
        /** Helper for rendering tokens */
        PrismTokenizer.prototype.tokenClass = function (token) {
            // Returns the basic token class + type and appends the aliases, if any 
            return token ? ('token ' + (token.type || '') + this.tokenAliases(token)) : '';
        };
        PrismTokenizer.prototype.tokenAliases = function (token) {
            // Skips when no aliases
            if (!token.alias) {
                return '';
            }
            // Appends the multiple aliases
            if (token.alias instanceof Array) {
                return token.alias.reduce(function (c, alias) { return c + ' ' + alias; }, '');
            }
            // Appends the single alias
            return ' ' + token.alias;
        };
        return PrismTokenizer;
    }());
    PrismTokenizer.decorators = [
        { type: core.Component, args: [{
                    selector: '[tokenize]',
                    template: "<!-- Loops on tokens -->\n<ng-container *ngFor=\"let token of tokens\">\n\n  <!-- Renders plain strings as text nodes -->\n  <ng-container *ngIf=\"isString(token); else spanToken\">{{ token }}</ng-container>\n\n  <!-- Spans the token recurring down the tree with the proper styling otherwise -->\n  <ng-template #spanToken>\n    <span [class]=\"tokenClass(token)\" [tokenize]=\"token.content\"></span>\n  </ng-template>\n\n</ng-container>"
                },] }
    ];
    PrismTokenizer.propDecorators = {
        tokenize: [{ type: core.Input }]
    };

    var PrismModule = /** @class */ (function () {
        function PrismModule() {
        }
        /** Initializes the PrismModule with extra language loaders */
        PrismModule.init = function (languages) {
            return {
                ngModule: PrismModule,
                providers: [{ provide: LANGUAGE_MODULES, useValue: languages }]
            };
        };
        return PrismModule;
    }());
    PrismModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        PrismHighlighter,
                        PrismTokenizer
                    ],
                    imports: [common.CommonModule],
                    exports: [PrismHighlighter],
                    providers: [PrismService]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.LANGUAGE_MODULES = LANGUAGE_MODULES;
    exports.PrismHighlighter = PrismHighlighter;
    exports.PrismModule = PrismModule;
    exports.PrismService = PrismService;
    exports.ɵa = PrismTokenizer;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=wizdm-prism.umd.js.map
