import { InjectionToken } from '@angular/core';
import { Token } from 'prismjs';
import { Observable } from 'rxjs';
/** Prism Language Modules Token */
export declare const LANGUAGE_MODULES: InjectionToken<PrismLanguage[]>;
/** List of language modules */
export declare type PrismLanguages = PrismLanguage[];
/** Language loader */
export interface PrismLanguage {
    name: string | string[] | '*';
    load: (name: string) => Promise<any>;
}
/** @dynamic - tells ngc to ignore the error on type PrismLanguages generated by strictEmitMetadata: true */
export declare class PrismService {
    private languages;
    constructor(languages: PrismLanguages);
    /** Tokenizes the input source by loading the grammar dynamically whenever necessary */
    tokenize(source: string, language: string): Observable<(string | Token)[]>;
    /** Loads the Grammar */
    private loadGrammar;
}
